<?php

namespace Factory;

use Zeedhi\DevOps\Model\Configurationmanager\Entities\Deploy as DeployEntity;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\Product;
use Zeedhi\DevOps\Model\Devops\Entities\ProductVersion;
use Zeedhi\DevOps\Model\Projectmanagement\Entities\Resource;
use \Zeedhi\DevOps\Model\Devops\Entities\ProductVersion as PreviousProductVersion;

class Deploy {
    public function save(DeployEntity $deploy = null, Product $product, ProductVersion $productVersion, Resource $resource,
                         DeployEntity $parent, $name, $isActive, $deployDate, $status, $pathBkp, $isCustomerDeploy, PreviousProductVersion $previousProductVersion = null) {

        if(empty($deploy)) {
            $deploy = new DeployEntity();
        }

        $deploy->setName($name);
        $deploy->setProduct($product);
        $deploy->setProductVersion($productVersion);
        $deploy->setPreviousProductVersion($previousProductVersion);
        $deploy->setIsActive($isActive);
        $deploy->setDeployDate($deployDate);
        $deploy->setStatus($status);
        $deploy->setPathBackup($pathBkp);
        $deploy->setParent($parent);
        $deploy->setIsCustomerDeploy($isCustomerDeploy);
        $deploy->setResource($resource);

        return $deploy;
    }

    public function saveAfterApply(DeployEntity $deploy, $isActive, $deployDate, $status, $pathBkp, $productVersion = null, $ticketId = null) {
        $deploy->setIsActive($isActive);
        $deploy->setDeployDate($deployDate);
        $deploy->setStatus($status);
        $deploy->setPathBackup($pathBkp);
        $deploy->setTicketId($ticketId);

        if($productVersion) {
            $deploy->setProductVersion($productVersion);
        }

        return $deploy;
    }
} 
